import tripleStore.oauth.settings as osettings

def getQuery(predicate, startDate ,username):
	sql = """
		SPARQL SELECT max(?object) as ?value xsd:date(?d) as ?d FROM <http://carre.kmi.open.ac.uk/users/""" +  username + """> WHERE 
		{
			 ?subject ?predicate ?object.
			 ?subject <http://carre.kmi.open.ac.uk/ontology/sensors.owl#hasDate> ?d.
			 FILTER ( ( xsd:date(?d) >= '""" + startDate + """'^^xsd:date) AND (?predicate= <""" + predicate + """>) )
		}
		GROUP BY xsd:date(?d)
	"""
	return sql

def getDataContinuous(username, password, measurement, period=14):
	import pandas as pd
	from datetime import date, timedelta
	if measurement in osettings.measurements.keys():
		predicate = osettings.measurements[measurement]
	else:
		return None

	d = pd.datetime.today() - timedelta(days=period)
	d = str(d.year) + d.strftime('%m') + d.strftime('%d')

	import tripleStore.VirtuosoHelper as VH
	rs = {}
	sql = getQuery(predicate, d, username)
	df = VH._fetchTriples(sql, username, password)

	df['date'] = df['d'].apply(pd.to_datetime)
	df = df[['date', 'value']]

	df = df.sort('date')
	
	df['value'] = df['value'].astype(float)

	df = df.reset_index().sort('date')
	del df['index']
	return df

def getAveragesDataContinuous(measurement, username, password, period=365, grouping="M"):
	df = getDataContinuous(measurement, username, password, period)
	df = df.set_index('date')
	davg = df.resample(grouping, how='mean')
	davg = davg.reset_index()
	return davg