# -*- coding: utf-8 -*-

# Create your views here.
#taken from https://www.youtube.com/watch?v=CFypO_LNmcc


from django.shortcuts import render_to_response
from django.http import HttpResponse
from django.http import HttpResponseRedirect
from django.contrib import auth
from django.core.context_processors import csrf
from django.template import RequestContext
from django.contrib.auth.decorators import login_required

import tripleStore.oauth.settings as osettings

def index(request):
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	if 'devices_username' in request.session.keys():
		import tripleStore.demo as demo
		plot_url = demo.foo()
		username = request.session['devices_username']
		password = NH._unsign(request.session['devices_password'])
		triples = VH.countTriples(username, password)
		countConnections = VH.countConnections(username, password)
		return render_to_response('devices_index.html',{'full_name': request.session['devices_username'], 'plot_url': plot_url, 'triples': triples, 'countConnections': countConnections},context_instance=RequestContext(request))
	else:
		return HttpResponseRedirect("/devices/accounts/login")
	st = "<a href='/devices/accounts/login'>login</a>"
	if request.user.is_authenticated():
		return HttpResponse("You are authenticated"+st)
	return HttpResponse("Hello, world. You're at the tripleStore index. You are NOT authenticated ["+st+"]")

def login(request):
	c = {}
	c.update(csrf(request))
	m = ""
	if "devices_message" in request.session.keys():
		m = request.session["devices_message"]
		del request.session["devices_message"]
	return render_to_response("devices_login.html", {'m':m},context_instance=RequestContext(request))

def auth_view(request):
	import tripleStore.NetHelper as NH
	username = request.POST.get('username','')
	password = request.POST.get('password','')
	user = auth.authenticate(username=username, password=password)

	if user is not None:
		request.session['devices_username'] = username
		request.session['devices_password'] = NH._sign(password)
		return HttpResponseRedirect("/devices/accounts/loggedin")
	else:
		import tripleStore.BootstrapHelper as BH
		request.session["devices_message"] = BH.generateHTMLWarning("Username or password are incorrect")
		return HttpResponseRedirect("/devices/accounts/login")

def auth_register(request):
	import tripleStore.NetHelper as NH
	c = NH.verifyCaptcha(request)
	if c==False:
		import tripleStore.BootstrapHelper as BH
		request.session["devices_message"] = BH.generateHTMLWarning("CAPTCHA verification failed, try again")
		return HttpResponseRedirect("/devices/accounts/register")

	next = request.GET.get('next','')
	if next!='':
		request.session["next"] = next
	username = request.POST.get('username','')
	password = request.POST.get('password','')
	password2 = request.POST.get('password2','')
	email = request.POST.get('email','')

	import tripleStore.BootstrapHelper as BH
	if len(username)<6:
		request.session["devices_message"] = BH.generateHTMLWarning("Username must be longer than 5 characters")
		return HttpResponseRedirect("/devices/accounts/register")

	if username.isdigit():
		request.session["devices_message"] = BH.generateHTMLWarning("Username contains only digits")
		return HttpResponseRedirect("/devices/accounts/register")
		

	if password!=password2:
		request.session["devices_message"] = BH.generateHTMLWarning("Password did not match, try again")
		return HttpResponseRedirect("/devices/accounts/register")

	tmp = NH.passwordStrength(password)
	if type(tmp) is str:
		request.session["devices_message"] = BH.generateHTMLWarning(tmp)
		return HttpResponseRedirect("/devices/accounts/register")
	
	if NH.validEmail(email) is False:
		request.session["devices_message"] = BH.generateHTMLWarning("Email is not valid")
		return HttpResponseRedirect("/devices/accounts/register")

	import tripleStore.VirtuosoHelper as VH
	rs = VH.registerUser(username, password, email)
	if type(rs) is str:
		request.session["devices_message"] = BH.generateHTMLWarning(rs)
		return HttpResponseRedirect("/devices/accounts/register")
	
	rs = VH.registerVirtuosoApp(username, password)
	if type(rs) is str:
		request.session["devices_message"] = BH.generateHTMLWarning(rs)
		return HttpResponseRedirect("/devices/accounts/register")

	request.session["devices_message"] = BH.generateHTMLSuccess("Registration successfull, you can try login!")
	return HttpResponseRedirect("/devices/accounts/login")

def change_password(request):
	import tripleStore.VirtuosoHelper as VH
	code = request.GET.get('code','')

	if 'devices_username' in request.session.keys():
				username = request.session['devices_username']
	else:
		sql = "SPARQL SELECT ?s ?p FROM <" + osettings.settings['carreSecureURL']+ "/__internals__> WHERE { ?s ?p \""+code+"\"^^xsd:string }"
		data = VH._fetchTriples(sql, "INSERT_ROOT_USERNAME", "INSERT_ROOT_PASSWORD")
		if len(data)<1:
			return HttpResponse("not a valid or active code")

		email = data.s.tolist()[0]
		email = email.replace(osettings.settings['carreSecureURL'] + "/", "")

		username = VH.getUserByEmail(email)

	if username=="":
		return HttpResponse("Something went wrong")

	m = ""
	if "devices_message" in request.session.keys():
		m = request.session["devices_message"]
		del request.session["devices_message"]
	return render_to_response("devices_change_password.html", {'code':code, 'm':m, 'username': username}, context_instance=RequestContext(request))

def do_change_password(request):
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	import tripleStore.BootstrapHelper as BH
	code = request.POST.get('code','')
	username = ""
	
	if code!='':
		sql = "SPARQL SELECT ?s ?p FROM <"+ osettings.settings['carreSecureURL'] + "/__internals__> WHERE { ?s ?p \""+code+"\"^^xsd:string }"
		data = VH._fetchTriples(sql, "INSERT_ROOT_USERNAME", "INSERT_ROOT_PASSWORD")
		if len(data)<1:
			return HttpResponse("not a valid or active code")

		email = data.s.tolist()[0]
		email = email.replace(osettings.settings['carreSecureURL'] + "/", "")

		username = VH.getUserByEmail(email)
	elif 'devices_username' in request.session.keys():
		username = request.session['devices_username']

	if username=="":
		return HttpResponse("Something went wrong")

	password = request.POST.get('password', '')
	password2 = request.POST.get('password2', '')

	if password!=password2:
		request.session["devices_message"] = BH.generateHTMLWarning("Password did not match, try again")
		if code!="":
			return HttpResponseRedirect("/devices/accounts/recover?code="+ code)
		return HttpResponseRedirect("/devices/accounts/recover")

	tmp = NH.passwordStrength(password)
	if type(tmp) is str:
		request.session["devices_message"] = BH.generateHTMLWarning(tmp)
		if code!="":
			return HttpResponseRedirect("/devices/accounts/recover?code="+ code)
		return HttpResponseRedirect("/devices/accounts/recover")

	VH.setUserPassword(username, password)
	if code!='':
		request.session["devices_message"] = BH.generateHTMLInfo("password changed")
	request.session['devices_password'] = NH._sign(password)
	return HttpResponseRedirect("/devices")

def generate_code(request):
	import tripleStore.NetHelper as NH
	import tripleStore.BootstrapHelper as BH
	email = request.POST.get('email', '')
	m = NH.sendPasswordReminder(email)
	if m==1:
		request.session["devices_message"] = BH.generateHTMLWarning("check your email")
		return HttpResponseRedirect("/devices/accounts/login")
	elif m=="1":
		request.session["devices_message"] = BH.generateHTMLWarning("check your email")
		return HttpResponseRedirect("/devices/accounts/login")
	
	request.session["devices_message"] = BH.generateHTMLWarning("Email not found")
	return HttpResponseRedirect("/devices/accounts/email")

def user_email(request):
	if "devices_message" in request.session.keys():
		m = request.session["devices_message"]
		del request.session["devices_message"]
		return render_to_response('devices_enter_email.html', {'m':m}, RequestContext(request))
	return render_to_response('devices_enter_email.html', RequestContext(request))

def loggedin(request):
	import tripleStore.NetHelper as NH
	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])

	if NH.probeService(username, password, "virtuoso")<1:
		return HttpResponseRedirect("/devices/oauth/virtuoso")

	if 'next' in request.session.keys():
		url = request.session["next"]
		del request.session["next"]
		return HttpResponseRedirect(url)

	return HttpResponseRedirect("/devices/")
	return render_to_response('devices_loggedin.html', {'full_name': request.session['devices_username']})

def invalid_login(request):
	return render_to_response('devices_invalid_login.html',RequestContext(request))

def logout(request):
	for sesskey in request.session.keys():
		del request.session[sesskey]
	auth.logout(request)
	return HttpResponseRedirect("/devices/accounts/login")

def register(request):
	if 'devices_message' in request.session.keys():
		m = request.session['devices_message']
		del request.session['devices_message']
	else:
		m = ""
	return render_to_response('devices_register.html',{'m':m},context_instance=RequestContext(request)) 

def user_info(request):
	if 'devices_username' in request.session.keys():
		st = request.session['devices_username']
	else:
		st = 'no user logged in'
	return render_to_response('devices_user.html', {'full_name': st})

def user_settings(request):
	return render_to_response('devices_settings.html',{'full_name': request.session['devices_username']}, context_instance=RequestContext(request))

def connectionRemove(request):
	import tripleStore.NetHelper as NH
	import tripleStore.BootstrapHelper as BH

	provider = request.GET.get('name', '')
	provider = provider.lower()
	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])

	if provider in ["fitbit","withings","ihealth", "misfit", "google", "googlefit", "medisana"]:
			rs = NH.connectionRemove(provider, username, password)

	request.session['devices_message'] = BH.generateInfoPage(provider + " connection successfully removed")
	request.session['devices_title'] = "CARRE devices - Connection Removed"
	
	return HttpResponseRedirect("/devices/info")

def ihealth_callback(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH

	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])
	verifier = request.GET.get('code', '')
	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"

	response = ohelper.get_token(username, "ihealth", verifier)
	rs = NH.storeIhealth(username, password, response)
	
	import tripleStore.BootstrapHelper as BH
	request.session['devices_message'] = BH.generateInfoPage("iHealth connection successfully established")
	request.session['devices_title'] = "CARRE devices - Connection Successfull"
	
	return HttpResponseRedirect("/devices/info")

def ihealth_oauth(request):
	import tripleStore.oauth.Helper as ohelper
	url = ohelper.make_authorization_url("ihealth")
	return HttpResponseRedirect(url)

def withings_callback(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH

	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])
	verifier = request.GET.get('oauth_verifier', '')
	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"

	sql = "SPARQL SELECT ?connection ?token FROM <" + osettings.settings['carreSecureURL'] + "/users/" + username + "> where {?connection <" + osettings.settings['carreManufacturerPredicate'] + "> <" + osettings.settings['carreManufacturerIRI'] + "/withings> . ?connection <" + osettings.settings['carreRequestTokenPredicate'] + "> ?token}"
	data = VH._fetchTriples(sql, username, password)
	oauth_token = data.token.tolist()[0]
	connectionId = data.connection.tolist()[0]


	sql = "SPARQL SELECT ?connection ?tokenSecret FROM <" + osettings.settings['carreSecureURL'] + "/users/" + username + "> where {?connection <" + osettings.settings['carreManufacturerPredicate'] + "> <" + osettings.settings['carreManufacturerIRI'] + "/withings> . ?connection <" + osettings.settings['carreRequestTokenSecretPredicate'] +"> ?tokenSecret}"
	data = VH._fetchTriples(sql, username, password)
	oauth_token_secret = data.tokenSecret.tolist()[0]

	try:
		response = ohelper.get_token(username, "withings", verifier, oauth_token, oauth_token_secret)
	except Exception, e:
		return HttpResponse(str(e))
	
	#store userId
	subject = "<" + connectionId + ">"
	predicate = "<" + osettings.settings['carreUserIdPredicate'] +">"
	object = "\"" + response['user_id'] + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#store access token
	subject = "<" + connectionId + ">"
	predicate = "<" + osettings.settings['carreAccessTokenPredicate'] + ">"
	object = "\"" + response['access_token'] + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)
	
	#store access token secret
	predicate = "<" + osettings.settings['carreAccessTokenSecretPredicate'] + ">"
	object = "\"" + response['access_token_secret'] + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	import sys
	sys.path.append('/data/web/devices/')
	import fetchHistoricalData
	fetchHistoricalData.updateWithings()

	import tripleStore.BootstrapHelper as BH
	request.session['devices_message'] = BH.generateInfoPage("Withings connection successfully established")
	request.session['devices_title'] = "CARRE devices - Connection Successfull"
	
	return HttpResponseRedirect("/devices/info")

def fitbit_callback(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	import datetime

	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])
	verifier = request.GET.get('oauth_verifier', '')
	oauth_token = request.GET.get('oauth_token', '')
	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"

	sql = "SPARQL SELECT ?connection ?token FROM <" + osettings.settings['carreSecureURL'] + "/users/" + username + "> where {?connection <" + osettings.settings['carreManufacturerPredicate'] + "> <" + osettings.settings['carreManufacturerIRI'] + "/fitbit> . ?connection <" + osettings.settings['carreRequestTokenPredicate'] + "> ?token}"
	data = VH._fetchTriples(sql, username, password)
	oauth_token = data.token.tolist()[0]
	connectionId = data.connection.tolist()[0]


	sql = "SPARQL SELECT ?connection ?tokenSecret FROM <" + osettings.settings['carreSecureURL'] +"/users/" + username + "> where {?connection <" + osettings.settings['carreManufacturerPredicate'] + "> <" + osettings.settings['carreManufacturerIRI'] + "/fitbit> . ?connection <" + osettings.settings['carreRequestTokenSecretPredicate'] + "> ?tokenSecret}"
	data = VH._fetchTriples(sql, username, password)
	oauth_token_secret = data.tokenSecret.tolist()[0]

	try:
		response = ohelper.get_token(username, "fitbit", verifier, oauth_token, oauth_token_secret)
	except Exception, e:
		return HttpResponse(str(e))
	#response contains: encoded_user_id, oauth_token, oauth_token_secret
	
	#store user id
	subject = "<" + connectionId + ">"
	predicate = "<" + osettings.settings['carreUserIdPredicate'] + ">"
	object = "\"" + response['encoded_user_id'] + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)
	

	#store access token
	predicate = "<" + osettings.settings['carreAccessTokenPredicate'] + ">"
	object = "\"" + response['oauth_token'] + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#store token secret
	predicate = "<" + osettings.settings['carreAccessTokenSecretPredicate'] + ">"
	object = "\"" + response['oauth_token_secret'] + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#store carretime
	subject = osettings.settings['carreManufacturerIRI'] + "/fitbit"
	predicate = osettings.settings['carreLastMeasuredPredicate']
	object = "\"" + osettings.settings['carretime'] + "\"^^xsd:date"
	VH.insertUniqueTriple(username,subject, predicate, object, username, password)

	#store first connected
	subject = osettings.settings['carreManufacturerIRI'] + "/fitbit"
	predicate = osettings.settings['carreFirstConnectedPredicate']
	object = "\"" + datetime.date.today().strftime("%Y-%m-%d") + "\"^^xsd:date"
	if VH.tripleExists(username, subject, predicate, username, password) == 0:
		VH.insertUniqueTriple(username,subject, predicate, object, username, password)
	
	import tripleStore.BootstrapHelper as BH
	request.session['devices_message'] = BH.generateInfoPage("Fitbit connection successfully established")
	request.session['devices_title'] = "CARRE devices - Connection Successfull"
	
	return HttpResponseRedirect("/devices/info")

def misfit_oauth(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	from uuid import uuid4
	import datetime

	response = ohelper.make_authorization_url("misfit")
	return HttpResponseRedirect(response)

def misfit_callback(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	import datetime
	from uuid import uuid4

	code = request.GET.get('code','')
	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])
	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"
	connectionId = str(uuid4())
	connectionIdIRI = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"

	token, user = ohelper.get_token(username, "misfit", code)
	# user is a dictionary with birthday, email, gender, userId

	#user has a new connection
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + ">"
	predicate = "<" + osettings.settings['carreConnectionPredicate'] + ">" 
	object = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	triples =[]
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#connection has misfit manufacturer
	subject = object
	predicate = "<" + osettings.settings['carreManufacturerPredicate'] + ">"
	object = "<" + osettings.settings['carreManufacturerIRI'] + "/misfit>"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	
	#store userId
	subject = connectionIdIRI
	predicate = "<" + osettings.settings['carreUserIdPredicate'] +">"
	object = "\"" + user['userId'] + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#store access token
	subject = connectionIdIRI
	predicate = "<" + osettings.settings['carreAccessTokenPredicate'] + ">"
	object = "\"" + token + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#store carretime
	triples = []
	subject = osettings.settings['carreManufacturerIRI'] + "/misfit"
	predicate = osettings.settings['carreLastMeasuredPredicate']
	object = "\"" + osettings.settings['carretime'] + "\"^^xsd:date"
	VH.insertUniqueTriple(username,subject, predicate, object, username, password)

	#store first connected
	subject = osettings.settings['carreManufacturerIRI'] + "/misfit"
	predicate = osettings.settings['carreFirstConnectedPredicate']
	object = "\"" + datetime.date.today().strftime("%Y-%m-%d") + "\"^^xsd:date"
	if VH.tripleExists(username, subject, predicate, username, password) == 0:
		VH.insertUniqueTriple(username,subject, predicate, object, username, password)

	import sys
	sys.path.append('/data/web/devices/')
	import fetchHistoricalData

	import tripleStore.BootstrapHelper as BH
	request.session['devices_message'] = BH.generateInfoPage("Misfit connection successfully established")
	request.session['devices_title'] = "CARRE devices - Connection Successfull"
	
	return HttpResponseRedirect("/devices/info")

	return HttpResponse(code)

def withings_oauth(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	from uuid import uuid4
	import datetime
	
	response, token = ohelper.make_authorization_url("withings")
	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])
	connectionId = str(uuid4())
	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"

	NH.connectionRemove("withings", username, password)

	#user has a new connection
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + ">"
	predicate = "<" + osettings.settings['carreConnectionPredicate'] + ">" 
	object = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	triples =[]
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#connection has withings manufacturer
	subject = object
	predicate = "<" + osettings.settings['carreManufacturerPredicate'] + ">"
	object = "<" + osettings.settings['carreManufacturerIRI'] + "/withings>"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#1. connection has credentials (access token)
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	predicate = "<" + osettings.settings['carreRequestTokenPredicate'] + ">"
	object = "\"" + token.get('oauth_token') + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	#return HttpResponse(str(subject + " " + predicate + " " + object))
	VH._insertTriplesToGraph(graphName, triples, username, password)
	

	#2. connection has credentials (access token secret)
	predicate = "<" + osettings.settings['carreRequestTokenSecretPredicate'] + ">"
	object = "\"" + token.get('oauth_token_secret') + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#store carretime
	triples = []
	subject = osettings.settings['carreManufacturerIRI'] + "/withings"
	predicate = osettings.settings['carreLastMeasuredPredicate']
	object = "\"" + osettings.settings['carretime'] + "\"^^xsd:date"
	VH.insertUniqueTriple(username,subject, predicate, object, username, password)

	#store first connected
	subject = osettings.settings['carreManufacturerIRI'] + "/withings"
	predicate = osettings.settings['carreFirstConnectedPredicate']
	object = "\"" + datetime.date.today().strftime("%Y-%m-%d") + "\"^^xsd:date"
	if VH.tripleExists(username, subject, predicate, username, password) == 0:
		VH.insertUniqueTriple(username,subject, predicate, object, username, password)
	
	return HttpResponseRedirect(response)
	return render_to_response('oauth_authorise.html', {'provider': 'withings', 'oauth_url': response},context_instance=RequestContext(request))

def fitbit_oauth(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	from uuid import uuid4

	url, token = ohelper.make_authorization_url("fitbit")
	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])
	connectionId = str(uuid4())
	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"

	NH.connectionRemove("fitbit", username, password)

	#user has a new connection
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + ">"
	predicate = "<" + osettings.settings['carreConnectionPredicate'] + ">" 
	object = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	triples =[]
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#connection has fitbit manufacturer
	subject = object
	predicate = "<" + osettings.settings['carreManufacturerPredicate'] + ">"
	object = "<" + osettings.settings['carreManufacturerIRI'] + "/fitbit>"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#1. connection has credentials (access token)
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	predicate = "<" + osettings.settings['carreRequestTokenPredicate'] + ">"
	object = "\"" + token.get('oauth_token') + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)
	

	#2. connection has credentials (access token secret)
	predicate = "<" + osettings.settings['carreRequestTokenSecretPredicate'] + ">"
	object = "\"" + token.get('oauth_token_secret') + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	# return HttpResponse(url)
	return HttpResponseRedirect(url)
	
	return render_to_response('oauth_authorise.html', {'provider': 'fitbit', 'oauth_url': url},context_instance=RequestContext(request))

def location_oauth(request):
	return HttpResponse("coming soon...")

def google_oauth(request):
	import tripleStore.oauth.Helper as ohelper
	url = ohelper.make_authorization_url("gcalendar")
	return HttpResponseRedirect(url)

def googlefit_oauth(request):
	import tripleStore.oauth.Helper as ohelper
	url = ohelper.make_authorization_url("googlefit")
	return HttpResponseRedirect(url)

def medisana_oauth(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.NetHelper as NH
	import tripleStore.VirtuosoHelper as VH
	from uuid import uuid4

	request_token, request_token_secret = ohelper.make_authorization_url("medisana")

	if 'devices_username' not in request.session.keys():
		return HttpResponseRedirect("/devices/accounts/login")
	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])

	connectionId = str(uuid4())
	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"
	NH.connectionRemove("medisana", username, password)

	#user has a new connection
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + ">"
	predicate = "<" + osettings.settings['carreConnectionPredicate'] + ">" 
	object = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	triples =[]
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#connection has medisana manufacturer
	subject = object
	predicate = "<" + osettings.settings['carreManufacturerPredicate'] + ">"
	object = "<" + osettings.settings['carreManufacturerIRI'] + "/medisana>"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#1. connection has credentials (request token)
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	predicate = "<" + osettings.settings['carreRequestTokenPredicate'] + ">"
	object = "\"" + request_token + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	#return HttpResponse(str(subject + " " + predicate + " " + object))
	VH._insertTriplesToGraph(graphName, triples, username, password)
	

	#2. connection has credentials (request token secret)
	predicate = "<" + osettings.settings['carreRequestTokenSecretPredicate'] + ">"
	object = "\"" + request_token_secret + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	url = osettings.settings["medisana-authorizationurl2"] + "?oauth_token=" + request_token	
	return HttpResponseRedirect(url)

def medisana_callback(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	if 'devices_username' not in request.session.keys():
		return HttpResponseRedirect("/devices/accounts/login")
	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])
	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"

	verifier = request.GET.get('oauth_verifier','')

	sql = "SPARQL SELECT ?connection ?token FROM <" + osettings.settings['carreSecureURL'] + "/users/" + username + "> where {?connection <" + osettings.settings['carreManufacturerPredicate'] + "> <" + osettings.settings['carreManufacturerIRI'] + "/medisana> . ?connection <" + osettings.settings['carreRequestTokenPredicate'] + "> ?token}"
	data = VH._fetchTriples(sql, username, password)
	oauth_token = data.token.tolist()[0]
	connectionId = data.connection.tolist()[0]


	sql = "SPARQL SELECT ?connection ?tokenSecret FROM <" + osettings.settings['carreSecureURL'] + "/users/" + username + "> where {?connection <" + osettings.settings['carreManufacturerPredicate'] + "> <" + osettings.settings['carreManufacturerIRI'] + "/medisana> . ?connection <" + osettings.settings['carreRequestTokenSecretPredicate'] +"> ?tokenSecret}"
	data = VH._fetchTriples(sql, username, password)
	oauth_token_secret = data.tokenSecret.tolist()[0]

	try:
		access_token, access_token_secret = ohelper.get_token(username, "medisana", verifier, oauth_token, oauth_token_secret)
	except Exception, e:
		return HttpResponse(str(e))

	#store access token
	subject = "<" + connectionId + ">"
	predicate = "<" + osettings.settings['carreAccessTokenPredicate'] + ">"
	object = "\"" + access_token + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)
	
	#store access token secret
	predicate = "<" + osettings.settings['carreAccessTokenSecretPredicate'] + ">"
	object = "\"" + access_token_secret + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	import tripleStore.BootstrapHelper as BH
	request.session['devices_message'] = BH.generateInfoPage("Medisana connection successfully established")
	request.session['devices_title'] = "CARRE devices - Connection Successfull"
	
	return HttpResponseRedirect("/devices/info")	

def google_callback(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	from uuid import uuid4

	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])
	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"
	connectionId = str(uuid4())

	code = request.GET.get('code','')
	token = ohelper.get_token(username, 'google',code)
	s_token = "\"" + token + "\"^^xsd:string"
	NH.connectionRemove("google", username, password)

	#user has a new connection
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + ">"
	predicate = "<" + osettings.settings['carreConnectionPredicate'] + ">"
	object = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	triples =[]
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#connection has Google manufacturer
	subject = object
	predicate = "<" + osettings.settings['carreManufacturerPredicate'] + ">"
	object = "<" + osettings.settings['carreManufacturerIRI'] + "/google>"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#connection has an access token
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	predicate = "<" + osettings.settings['carreAccessTokenPredicate'] + ">"
	triples =[]
	triples.append(subject + " " + predicate + " " + s_token)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#now add the events
	events = NH.fetchGoogleCalendar(token)
	connectionId = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	rs = NH.storeGoogleCalendar(username,password,connectionId, events)

	import tripleStore.BootstrapHelper as BH
	request.session['devices_message'] = BH.generateInfoPage("successfully inserted " + str(len(events)) + " events.")
	request.session['devices_title'] = "CARRE devices - Connection Successfull"
	
	return HttpResponseRedirect("/devices/info")

def googlefit_callback(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	from uuid import uuid4
	import datetime

	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])
	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"
	connectionId = str(uuid4())

	code = request.GET.get('code','')
	token, token_expiry, expires_in, refresh_token = ohelper.get_token(username, 'googlefit',code)
	s_token = "\"" + token + "\"^^xsd:string"
	s_refresh_token = "\"" + refresh_token + "\"^^xsd:string"
	NH.connectionRemove("googlefit", username, password)

	#user has a new connection
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + ">"
	predicate = "<" + osettings.settings['carreConnectionPredicate'] + ">"
	connectionIRI = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	object = connectionIRI
	triples =[]
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#1. connection has googlefit manufacturer
	subject = object
	predicate = "<" + osettings.settings['carreManufacturerPredicate'] + ">"
	object = "<" + osettings.settings['carreManufacturerIRI'] + "/googlefit>"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#2. connection has credentials (expires)
	subject = connectionIRI
	predicate = "<" + osettings.settings['carreExpiryPredicate'] + ">"
	object = "\"" + str(expires_in) + "\"^^xsd:int"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)
	

	#2.5 connection expires
	import dateutil.parser
	e = dateutil.parser.parse(token_expiry)
	subject = connectionIRI
	subject = subject[1:]
	subject = subject[:-1]
	predicate = osettings.settings['carreExpiryDatePredicate']
	object = "\"" + e.strftime("%Y-%m-%dT%H:%M:%SZ") + "\"^^xsd:datetime"
	rs = VH.insertUniqueTriple(username,subject, predicate, object, username, password)

	#3. connection has an access token
	subject = connectionIRI
	predicate = "<" + osettings.settings['carreAccessTokenPredicate'] + ">"
	triples =[]
	triples.append(subject + " " + predicate + " " + s_token)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#4. connection has a refresh token token
	subject = connectionIRI
	predicate = "<" + osettings.settings['carreRefreshTokenPredicate'] + ">"
	triples =[]
	triples.append(subject + " " + predicate + " " + s_refresh_token)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#store carretime
	triples = []
	subject = osettings.settings['carreManufacturerIRI'] + "/googlefit"
	predicate = osettings.settings['carreLastMeasuredPredicate']
	object = "\"" + osettings.settings['carretime'] + "\"^^xsd:date"
	rs = VH.insertUniqueTriple(username,subject, predicate, object, username, password)

	#store first connected
	subject = osettings.settings['carreManufacturerIRI'] + "/googlefit"
	predicate = osettings.settings['carreFirstConnectedPredicate']
	object = "\"" + datetime.date.today().strftime("%Y-%m-%d") + "\"^^xsd:date"
	if VH.tripleExists(username, subject, predicate, username, password) == 0:
		rs = VH.insertUniqueTriple(username,subject, predicate, object, username, password)


	import tripleStore.BootstrapHelper as BH
	request.session['devices_message'] = BH.generateInfoPage("Google Fit connection successfully established")
	request.session['devices_title'] = "CARRE devices - Connection Successfull"
	
	return HttpResponseRedirect("/devices/info")

def sparql(request):
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH

	if 'devices_username' not in request.session.keys():
		request.session['next'] = request.path
		return HttpResponseRedirect("/devices/accounts/login")

	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])
	sql = request.GET.get('sql','')
	if sql=="":
		s = ("PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>\n"
"PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>\n"
"PREFIX carreSensors: <" + osettings.settings['carreSensorsOntologyURL'] + "#>\n"
"PREFIX carreManufacturer: <" + osettings.settings['carreManufacturerIRI'] + "/>\n"
"PREFIX carreUsers: <" + osettings.settings['carreSecureURL'] + "/users/>\n\n")
		sql = ("SPARQL " + s + "SELECT ?subject ?predicate ?object FROM <" + osettings.settings['carreSecureURL'] + "/users/" + username + "> WHERE { ?subject ?predicate ?object }")
		return render_to_response('sparql.html',{'sql':sql, 'full_name': request.session['devices_username']},context_instance=RequestContext(request))

	import pandas as pd
	df = ""
	try:
		df = VH._fetchTriples(sql, username, password)
	except Exception, e:
		data = "<code>" + str(e) + "</code"
	pd.options.display.max_colwidth = 1000
	if df is None:
		data = "Query returned no results"
	if isinstance(df, pd.core.frame.DataFrame):
		data = df.to_html()
		data = data.replace("dataframe", "table table-condensed table-hover carre-results")
		data = "<div class='table-responsive small'>" + data + "</div>"
	
	return render_to_response('sparql.html',{'sql':sql, 'data': data},context_instance=RequestContext(request))

def explore(request):
	import pandas as pd
	import tripleStore.VisualisationsHelper as VSH
	import tripleStore.NetHelper as NH
	import tripleStore.carre as carre

	measurement = request.GET.get('q','')
	if measurement == "":
		measurement = "Steps"

	period = request.GET.get('p','')
	try:
		period = int(period)
	except ValueError:
		period = 365

	if 'devices_username' not in request.session.keys():
		request.session['next'] = request.path
		return HttpResponseRedirect("/devices/accounts/login")
	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])

	df = carre.getDataContinuous(measurement, username,password)
	if type(df) is not pd.DataFrame:
		return render_to_response('devices_explore.html',{'body':"no data found", 'title':measurement},context_instance=RequestContext(request))
	df = df.set_index('date')

	
	monthly = df.resample("1M", how="mean")#, loffset='-15D')
	monthly.index = pd.DatetimeIndex(monthly.index) + pd.DateOffset(-15)
	monthly = monthly.reset_index()
	monthly.rename(columns={'index': 'x'}, inplace=True)
	monthly.rename(columns={'value': 'y'}, inplace=True)
	monthly['group'] = 1
	
	df = df.reset_index()
	df.rename(columns={'date': 'x'}, inplace=True)
	df.rename(columns={'value': 'y'}, inplace=True)

	import copy
	overall = copy.deepcopy(df)
	overall['y'] = overall['y'].mean()
	overall['group'] = 2
	overall = pd.concat([overall.head(1), overall.tail(1)])
	
	daily = df
	daily['group'] = 0

	df = pd.concat([daily, monthly, overall])
	df.y = df.y.astype(float)
	response = df.to_json(orient='records',date_format='iso')
	return render_to_response('devices_explore.html',{'body':response, 'title':measurement},context_instance=RequestContext(request))

def charts(request):
	import pandas as pd
	import tripleStore.VisualisationsHelper as VSH
	import tripleStore.NetHelper as NH
	import tripleStore.carre as carre	

	measurement = request.GET.get('q','')
	if measurement == "":
		measurement = "Steps"

	period = request.GET.get('p','')
	try:
		period = int(period)
	except ValueError:
		period = 7

	if 'devices_username' not in request.session.keys():
		request.session['next'] = request.path
		return HttpResponseRedirect("/devices/accounts/login")

	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])

	df = carre.getDataContinuous(measurement, username,password)
	if type(df) is not pd.DataFrame:
		return render_to_response('devices_explore.html',{'body':"no data found", 'title':measurement},context_instance=RequestContext(request))	
	df = df.set_index('date')
	monthly = df.resample("1M", how="mean")
	monthly.index = pd.DatetimeIndex(monthly.index) + pd.DateOffset(-15)
	monthly = monthly.reset_index()
	monthly.rename(columns={'index': 'x'}, inplace=True)
	monthly.rename(columns={'value': 'y'}, inplace=True)
	monthly['group'] = 1
	
	df = df.reset_index()
	df.rename(columns={'date': 'x'}, inplace=True)
	df.rename(columns={'value': 'y'}, inplace=True)

	import copy
	overall = copy.deepcopy(df)
	overall['y'] = overall['y'].mean()
	overall['group'] = 2
	overall = pd.concat([overall.head(1), overall.tail(1)])
	
	daily = df
	daily['group'] = 0

	df = pd.concat([daily, monthly, overall])
	response = df.to_json(orient='records',date_format='iso')

	json_description, json = carre.fetchCaloriesPie(username, password)

	return render_to_response('devices_explore.html',{'body':response,'title':measurement, 'json_description':json_description,'json':json},context_instance=RequestContext(request))

def probe_service(request):
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	import json
	
	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])
	providers = ["fitbit", "withings", "ihealth", "google", "location", "virtuoso", "misfit", "googlefit", "medisana"]
	s = {}
	for provider in providers:
		isUp = NH.probeService(username, password, provider)
		s[provider] = isUp
	rs = json.dumps(s)
	return HttpResponse(rs)

def message(request):
	m = ""
	if "devices_message" in request.session.keys():
		m = request.session["devices_message"]
		del request.session["devices_message"]

	t = ""
	if "devices_title" in request.session.keys():
		t = request.session["devices_title"]
		del request.session["devices_title"]
	

	return render_to_response("mbox.html", {'message':m, 'title':t},context_instance=RequestContext(request))

# oauth/virtuoso
def virtuoso_oauth(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.NetHelper as NH
	import tripleStore.VirtuosoHelper as VH
	from uuid import uuid4

	if 'devices_username' not in request.session.keys():
		return HttpResponseRedirect("/devices/accounts/login")
	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])

	d = ohelper.make_authorization_url("virtuoso", username)

	url = "http://carre.kmi.open.ac.uk:8890/OAuth/authorize"
	data = {}
	data['oauth_token'] = d['oauth_token']

	data['oauth_callback'] = osettings.settings['virtuoso-landing']
	
	connectionId = str(uuid4())
	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"
	NH.connectionRemove("virtuoso", username, password)

	#user has a new connection
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + ">"
	predicate = "<" + osettings.settings['carreConnectionPredicate'] + ">" 
	object = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	triples =[]
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#connection has virtuoso manufacturer
	subject = object
	predicate = "<" + osettings.settings['carreManufacturerPredicate'] + ">"
	object = "<" + osettings.settings['carreManufacturerIRI'] + "/virtuoso>"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	#1. connection has credentials (access token)
	subject = "<" + osettings.settings['carreSecureURL'] + "/users/" + username + "/" + osettings.settings['carreConnectionIRI'] + "/" + connectionId + ">"
	predicate = "<" + osettings.settings['carreRequestTokenPredicate'] + ">"
	object = "\"" + data['oauth_token'] + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)
	

	#2. connection has credentials (access token secret)
	predicate = "<" + osettings.settings['carreRequestTokenSecretPredicate'] + ">"
	object = "\"" + d['oauth_token_secret'] + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	import requests
	rs = requests.get(url, params=data)
	return HttpResponseRedirect(rs.url)

# oauth/virtuoso/callback
def virtuoso_callback(request):
	import tripleStore.oauth.Helper as ohelper
	import tripleStore.oauth.settings as osettings
	import tripleStore.VirtuosoHelper as VH
	import tripleStore.NetHelper as NH
	
	username = request.session['devices_username']
	password = NH._unsign(request.session['devices_password'])

	# get oauth_token
	sql = "SPARQL SELECT ?connection ?token FROM <" + osettings.settings['carreSecureURL'] + "/users/" + username + "> where {?connection <" + osettings.settings['carreManufacturerPredicate'] + "> <" + osettings.settings['carreManufacturerIRI'] + "/virtuoso> . ?connection <" + osettings.settings['carreRequestTokenPredicate'] + "> ?token}"
	data = VH._fetchTriples(sql, username, password)
	oauth_token = data.token.tolist()[0]
	connectionId = data.connection.tolist()[0]


	sql = "SPARQL SELECT ?connection ?tokenSecret FROM <" + osettings.settings['carreSecureURL'] + "/users/" + username + "> where {?connection <" + osettings.settings['carreManufacturerPredicate'] + "> <" + osettings.settings['carreManufacturerIRI'] + "/virtuoso> . ?connection <" + osettings.settings['carreRequestTokenSecretPredicate'] +"> ?tokenSecret}"
	data = VH._fetchTriples(sql, username, password)
	oauth_token_secret = data.tokenSecret.tolist()[0] 


	import requests
	from requests_oauthlib import OAuth1
	import oauthlib
	import urllib
	provider = "virtuoso"
	access_token_url = osettings.settings[provider + "-authorizationurl3"]
	client_key, client_secret = ohelper.getVirtuosoAppTokens(username) #user-specific

	client = oauthlib.oauth1.Client(client_key=client_key, resource_owner_key=oauth_token,resource_owner_secret=oauth_token_secret,signature_type=oauthlib.oauth1.SIGNATURE_TYPE_QUERY)
	creds = {'Authorization': 'Basic', 'x_auth_username': username, 'xauth_password': password}
	uri, headers, body = client.sign(access_token_url)
	
	import requests
	rs = requests.get(uri)
	c = rs.content

	from urlparse import parse_qs
	d = parse_qs(c)
	d['oauth_token'] = d['oauth_token'][0]
	d['oauth_token_secret'] = d['oauth_token_secret'][0]

	graphName = "<" + osettings.settings['carreSecureURL'] + "/users/" + username  + ">"
	#store access token
	subject = "<" + connectionId + ">"
	predicate = "<" + osettings.settings['carreAccessTokenPredicate'] + ">"
	object = "\"" + d['oauth_token'] + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)
	
	#store access token secret
	predicate = "<" + osettings.settings['carreAccessTokenSecretPredicate'] + ">"
	object = "\"" + d['oauth_token_secret'] + "\"^^xsd:string"
	triples = []
	triples.append(subject + " " + predicate + " " + object)
	VH._insertTriplesToGraph(graphName, triples, username, password)

	import tripleStore.BootstrapHelper as BH
	request.session['devices_message'] = BH.generateInfoPage("Virtuoso connection successfully established")
	request.session['devices_title'] = "CARRE devices - Connection Successfull"
	
	return HttpResponseRedirect("/devices/info")

